<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/class.reflectionclass.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'pt_BR',
  ),
  'this' => 
  array (
    0 => 'reflectionclass.newlazyproxy.php',
    1 => 'ReflectionClass::newLazyProxy',
  ),
  'up' => 
  array (
    0 => 'class.reflectionclass.php',
    1 => 'ReflectionClass',
  ),
  'prev' => 
  array (
    0 => 'reflectionclass.newlazyghost.php',
    1 => 'ReflectionClass::newLazyGhost',
  ),
  'next' => 
  array (
    0 => 'reflectionclass.resetaslazyghost.php',
    1 => 'ReflectionClass::resetAsLazyGhost',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'pt_BR',
    'path' => 'reference/reflection/reflectionclass/newlazyproxy.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="reflectionclass.newlazyproxy" class="refentry">
 <div class="refnamediv">
  <h1 class="refname">ReflectionClass::newLazyProxy</h1>
  <p class="verinfo">(PHP 8 &gt;= 8.4.0)</p><p class="refpurpose"><span class="refname">ReflectionClass::newLazyProxy</span> &mdash; <span class="dc-title">Cria uma nova instância de proxy lento</span></p>

 </div>

 <div class="refsect1 description" id="refsect1-reflectionclass.newlazyproxy-description">
  <h3 class="title">Descrição</h3>
  <div class="methodsynopsis dc-description">
   <span class="modifier">public</span> <span class="methodname"><strong>ReflectionClass::newLazyProxy</strong></span>(<span class="methodparam"><span class="type"><a href="language.types.callable.php" class="type callable">callable</a></span> <code class="parameter">$factory</code></span>, <span class="methodparam"><span class="type"><a href="language.types.integer.php" class="type int">int</a></span> <code class="parameter">$options</code><span class="initializer"> = 0</span></span>): <span class="type"><a href="language.types.object.php" class="type object">object</a></span></div>

  <p class="simpara">
   Cria uma nova instância de proxy lento da classe, anexando a
   função <code class="parameter">factory</code> a ela. O construtor não é
   chamado e as propriedades não são definidas com seus valores padrão. Quando é
   feita uma tentativa de observar ou modificar o estado do proxy pela primeira
   vez, a função de fábrica é chamada para fornecer uma instância real, que
   é então anexada ao proxy. Depois disso, todas as interações subsequentes
   com o proxy são encaminhadas para a instância real. Consulte
   <a href="language.oop5.lazy-objects.php#language.oop5.lazy-objects.initialization-triggers" class="link">Gatilhos de
   Inicialização</a> e <a href="language.oop5.lazy-objects.php#language.oop5.lazy-objects.initialization-sequence" class="link">Sequência
   de Inicialização</a> .
  </p>
 </div>


 <div class="refsect1 parameters" id="refsect1-reflectionclass.newlazyproxy-parameters">
  <h3 class="title">Parâmetros</h3>
  <dl>
   
    <dt><code class="parameter">factory</code></dt>
    <dd>
     <span class="simpara">
      A fábrica é uma função de retorno com a seguinte assinatura:
     </span>
     <p class="para">
      <div class="methodsynopsis dc-description">
       <span class="methodname"><span class="replaceable">factory</span></span>(<span class="methodparam"><span class="type"><a href="language.types.object.php" class="type object">object</a></span> <code class="parameter">$object</code></span>): <span class="type"><a href="language.types.object.php" class="type object">object</a></span></div>

      <dl>
       
        <dt><code class="parameter">object</code></dt>
        <dd>
         <span class="simpara">
          O parâmetro <code class="parameter">object</code> informa o objeto que está
          sendo inicializado. Neste ponto, o objeto não está mais marcado como
          lento e acessá-lo não aciona a inicialização novamente.
         </span>
        </dd>
       
      </dl>
     </p>
     <span class="simpara">
      A função de fábrica deve retornar um objeto, chamado de
      <em>instância real</em>, que é então anexado ao
      proxy. Esta instância real não deve ser lenta e não deve ser o
      próprio proxy. Se a instância real não tiver a mesma classe
      do proxy, a classe do proxy deverá ser uma subclasse da classe da
      instância real, sem propriedades adicionais, e não deverá substituir os métodos
      <span class="methodname"><strong>__destruct()</strong></span> ou
      <span class="methodname"><strong>__clone()</strong></span>.
     </span>
    </dd>
   
   
    <dt><code class="parameter">options</code></dt><dd>
     <p class="para">
      <code class="parameter">options</code> pode ser uma combinação das seguintes
      opções:
      <dl>
       
        <dt>
         <strong><code><a href="class.reflectionclass.php#reflectionclass.constants.skip-initialization-on-serialize">ReflectionClass::SKIP_INITIALIZATION_ON_SERIALIZE</a></code></strong>
        </dt>
        <dd>
         <span class="simpara">
          Por padrão, a serialização de um objeto lento aciona sua
          inicialização. Definir essa opção impede a inicialização, permitindo
          que objetos lentos sejam serializados sem serem inicializados.
         </span>
        </dd>
       
      </dl>
     </p>
    </dd>
   
  </dl>
 </div>


 <div class="refsect1 returnvalues" id="refsect1-reflectionclass.newlazyproxy-returnvalues">
  <h3 class="title">Valor Retornado</h3>
  <p class="simpara">
   Retorna uma instância de proxy lento. Se o objeto não tiver propriedades, ou se todas as suas
   propriedades forem estáticas ou virtuais, uma instância normal (não-lenta) será retornada.
   Veja também
   <a href="language.oop5.lazy-objects.php#language.oop5.lazy-objects.lifecycle" class="link">Ciclo de Vida de Objetos
   Lentos</a>.
  </p>
 </div>


 <div class="refsect1 errors" id="refsect1-reflectionclass.newlazyproxy-errors">
  <h3 class="title">Erros/Exceções</h3>
  <p class="simpara">
   Um <span class="classname"><a href="class.error.php" class="classname">Error</a></span> se a classe for interna ou estender uma
   classe interna exceto <span class="classname"><a href="class.stdclass.php" class="classname">stdClass</a></span>.
  </p>
 </div>


 <div class="refsect1 examples" id="refsect1-reflectionclass.newlazyproxy-examples">
  <h3 class="title">Exemplos</h3>
  <div class="example" id="example-5378">
   <p><strong>Exemplo #1 Uso básico</strong></p>
   <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /></span><span style="color: #007700">class </span><span style="color: #0000BB">Example </span><span style="color: #007700">{<br />    public function </span><span style="color: #0000BB">__construct</span><span style="color: #007700">(public </span><span style="color: #0000BB">int $prop</span><span style="color: #007700">) {<br />        echo </span><span style="color: #0000BB">__METHOD__</span><span style="color: #007700">, </span><span style="color: #DD0000">"\n"</span><span style="color: #007700">;<br />    }<br />}<br /><br /></span><span style="color: #0000BB">$reflector </span><span style="color: #007700">= new </span><span style="color: #0000BB">ReflectionClass</span><span style="color: #007700">(</span><span style="color: #0000BB">Example</span><span style="color: #007700">::class);<br /></span><span style="color: #0000BB">$object </span><span style="color: #007700">= </span><span style="color: #0000BB">$reflector</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">newLazyProxy</span><span style="color: #007700">(function (</span><span style="color: #0000BB">Example $object</span><span style="color: #007700">) {<br />     </span><span style="color: #0000BB">$realInstance </span><span style="color: #007700">= new </span><span style="color: #0000BB">Example</span><span style="color: #007700">(</span><span style="color: #0000BB">1</span><span style="color: #007700">);<br />     return </span><span style="color: #0000BB">$realInstance</span><span style="color: #007700">;<br />});<br /><br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$object</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$object </span><span style="color: #007700">instanceof </span><span style="color: #0000BB">Example</span><span style="color: #007700">);<br /><br /></span><span style="color: #FF8000">// Aciona a inicialização e encaminha a busca de propriedade para a instância real<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$object</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">prop</span><span style="color: #007700">);<br /><br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$object</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   <div class="example-contents"><p>O exemplo acima produzirá:</p></div>
   <div class="example-contents screen">
<div class="examplescode"><pre class="examplescode">lazy proxy object(Example)#3 (0) {
  [&quot;prop&quot;]=&gt;
  uninitialized(int)
}
bool(true)
Example::__construct
int(1)
lazy proxy object(Example)#3 (1) {
  [&quot;instance&quot;]=&gt;
  object(Example)#4 (1) {
    [&quot;prop&quot;]=&gt;
    int(1)
  }
}</pre>
</div>
   </div>
  </div>
 </div>


 <div class="refsect1 seealso" id="refsect1-reflectionclass.newlazyproxy-seealso">
  <h3 class="title">Veja Também</h3>
  <ul class="simplelist">
   <li><a href="language.oop5.lazy-objects.php" class="link">Lazy objects</a></li>
   <li><span class="methodname"><a href="reflectionclass.newlazyghost.php" class="methodname" rel="rdfs-seeAlso">ReflectionClass::newLazyGhost()</a> - Cria uma nova inst&acirc;ncia de fantasma lento</span></li>
   <li><span class="methodname"><a href="reflectionclass.newinstancewithoutconstructor.php" class="methodname" rel="rdfs-seeAlso">ReflectionClass::newInstanceWithoutConstructor()</a> - Cria uma nova inst&acirc;ncia de classe sem invocar o construtor</span></li>
   <li><span class="methodname"><a href="reflectionclass.resetaslazyproxy.php" class="methodname" rel="rdfs-seeAlso">ReflectionClass::resetAsLazyProxy()</a> - Redefine um objeto e o marca como lento</span></li>
   <li><span class="methodname"><a href="reflectionclass.marklazyobjectasinitialized.php" class="methodname" rel="rdfs-seeAlso">ReflectionClass::markLazyObjectAsInitialized()</a> - Marca um objeto lento como inicializado sem chamar o inicializador ou a f&aacute;brica</span></li>
   <li><span class="methodname"><a href="reflectionclass.initializelazyobject.php" class="methodname" rel="rdfs-seeAlso">ReflectionClass::initializeLazyObject()</a> - For&ccedil;a a inicializa&ccedil;&atilde;o de um objeto lento</span></li>
   <li><span class="methodname"><a href="reflectionclass.isuninitializedlazyobject.php" class="methodname" rel="rdfs-seeAlso">ReflectionClass::isUninitializedLazyObject()</a> - Verifica se um objeto &eacute; lento e n&atilde;o inicializado</span></li>
   <li><span class="methodname"><a href="reflectionproperty.setrawvaluewithoutlazyinitialization.php" class="methodname" rel="rdfs-seeAlso">ReflectionProperty::setRawValueWithoutLazyInitialization()</a> - Define o valor bruto da propriedade sem acionar a inicializa&ccedil;&atilde;o lenta</span></li>
   <li><span class="methodname"><a href="reflectionproperty.skiplazyinitialization.php" class="methodname" rel="rdfs-seeAlso">ReflectionProperty::skipLazyInitialization()</a> - Marca a propriedade como n&atilde;o lenta</span></li>
   <li><span class="methodname"><a href="reflectionproperty.islazy.php" class="methodname" rel="rdfs-seeAlso">ReflectionProperty::isLazy()</a> - Verifica se uma propriedade &eacute; lenta</span></li>
  </ul>
 </div>


</div><?php manual_footer($setup); ?>